Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/FilteredListModel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/FilteredListModel.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/FilteredListModel.java	(revision 44259)
@@ -8,12 +8,14 @@
 import java.util.ArrayList;
 import java.util.Comparator;
 import java.util.List;
+import java.util.Objects;
 import javax.swing.AbstractListModel;
 import javax.swing.SwingUtilities;
 import org.apache.commons.io.FilenameUtils;
+import org.apache.commons.lang3.ObjectUtils;
 import org.apache.commons.lang3.StringUtils;
-import org.gvsig.expressionevaluator.swing.Element.ConstantElement;
-import org.gvsig.tools.swing.api.ListElement;
+import org.gvsig.tools.util.LabeledValue;
+import org.gvsig.tools.util.LabeledValueImpl;
 
 /**
  *
@@ -21,8 +23,8 @@
  */
 class FilteredListModel extends AbstractListModel {
 
-    private List<ListElement> elements;
-    private List<ListElement> filteredElements;
+    private List<LabeledValue> elements;
+    private List<LabeledValue> filteredElements;
     private String filter;
 
     public FilteredListModel() {
@@ -37,17 +39,21 @@
     }
 
     @Override
-    public Object getElementAt(int index) {
+    public LabeledValue getElementAt(int index) {
         return this.filteredElements.get(index);
     }
 
-    void addElement(ListElement element) {
+    void addElement(LabeledValue element) {
         this.elements.add(element);
         if (this.elements != this.filteredElements) {
             this.filteredElements.add(element);
         }
     }
 
+    void addElement(Object element) {
+        this.addElement(new LabeledValueImpl<>(Objects.toString(element, ""), element));
+    }
+
     public void setFilter(String filter) {
         if (StringUtils.isEmpty(filter)) {
             this.filter = null;
@@ -55,7 +61,7 @@
         } else {
             this.filter = filter;
             this.filteredElements = new ArrayList<>();
-            for (ListElement element : elements) {
+            for (LabeledValue element : elements) {
                 if (FilenameUtils.wildcardMatch(element.getValue().toString().toLowerCase(), this.filter.toLowerCase())) {
                     this.filteredElements.add(element);
                 }
@@ -97,29 +103,11 @@
     }
 
     private void sortForeground(final boolean ascending) {
-        final List<ListElement> items = new ArrayList<>(elements);
-        final Comparator comparator = Utils.naturalComparator();
-        items.sort(new Comparator<ListElement>() {
+        final List items = new ArrayList<>(elements);
+        items.sort(new Comparator<Comparable>() {
             @Override
-            public int compare(ListElement o1, ListElement o2) {
-                int r;
-                if (o1 == null && o2 == null) {
-                    r = 0;
-                } else if (o1 == null && o2 != null) {
-                    r = -1;
-                } else if (o1 != null && o2 == null) {
-                    r = 1;
-                } else {
-                    if( o1.getValue() instanceof ConstantElement &&
-                        o2.getValue() instanceof ConstantElement ) {
-                        r = comparator.compare(
-                            ((ConstantElement)o1.getValue()).getValue(),
-                            ((ConstantElement)o2.getValue()).getValue()
-                        );
-                    } else {
-                        r = comparator.compare(o1.getValue(),o2.getValue());
-                    }
-                }
+            public int compare(Comparable o1, Comparable o2) {
+                int r = ObjectUtils.compare(o1, o2);
                 if (ascending) {
                     return r;
                 }
@@ -135,8 +123,4 @@
         }
     }
 
-    void addElement(Object data) {
-        ListElement e = new ListElement(data.toString(), data);
-        this.addElement(e);
-    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionPicker.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionPicker.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/DefaultJExpressionPicker.java	(revision 44259)
@@ -3,7 +3,6 @@
 import java.awt.BorderLayout;
 import java.util.Collection;
 import java.util.List;
-import java.util.Map;
 import javax.swing.JButton;
 import javax.swing.JComponent;
 import javax.swing.JPanel;
@@ -41,6 +40,11 @@
         this.add(text, BorderLayout.CENTER);
         this.add(button, BorderLayout.LINE_END);
     }
+
+    @Override
+    public Preferences getPreferences() {
+        return this.controller.getPreferences();
+    }
     
     @Override
     public ExpressionPickerController getController() {
@@ -62,18 +66,7 @@
         return this;
     }
 
-
     @Override
-    public int getSimpleElementsLimit() {
-        return this.controller.getSimpleElementsLimit();
-    }
-
-    @Override
-    public void setSimpleElementsLimit(int limit) {
-        this.controller.setSimpleElementsLimit(limit);
-    }
-    
-    @Override
     public List<Element> getElements() {
         return this.controller.getElements();
     }
@@ -109,16 +102,6 @@
     }
 
     @Override
-    public void setScriptsEnabled(boolean enabled) {
-        this.controller.setScriptsEnabled(enabled);
-    }
-
-    @Override
-    public boolean getScriptsEnabled() {
-        return this.controller.getScriptsEnabled();
-    }
-
-    @Override
     public SymbolTable getPreviewSymbolTable() {
         return this.controller.getPreviewSymbolTable();
     }
@@ -128,28 +111,4 @@
         this.controller.setPreviewSymbolTable(symbolTable);
     }
 
-    @Override
-    public void setSQLCompatible(boolean sqlCompatible) {
-        this.controller.setSQLCompatible(sqlCompatible);
-    }
-
-    @Override
-    public boolean isSQLCompatible() {
-        return this.controller.isSQLCompatible();
-    }
-
-    @Override
-    public Object getProperty(String string) {
-        return this.controller.getProperty(string);
-    }
-
-    @Override
-    public void setProperty(String string, Object o) {
-        this.controller.setProperty(string, o);
-    }
-
-    @Override
-    public Map<String, Object> getProperties() {
-        return this.controller.getProperties();
-    }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultFunctionElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultFunctionElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultFunctionElement.java	(revision 44259)
@@ -28,17 +28,16 @@
         implements FunctionElement {
 
     private final Function function;
-    private final ExpressionBuilderConfig config;
 
-    public DefaultFunctionElement(ExpressionBuilderConfig config, Function function) {
+    public DefaultFunctionElement(Function function) {
         super(
                 function.name(),
+                function.name(),
                 function.isSQLCompatible()
                 ? "expressionbuilder-element-function-sql"
                 : "expressionbuilder-element-function"
         );
         this.function = function;
-        this.config = config;
     }
 
     @Override
@@ -48,7 +47,7 @@
 
     @Override
     public boolean isEnabled() {
-        if( this.config.isSQLCompatible() ) {
+        if( this.getConfig().getPreferences().isSQLCompatible() ) {
             return this.function.isSQLCompatible();
         }
         return true;
@@ -65,6 +64,26 @@
     }
 
     @Override
+    public String getName() {
+        return this.function.name();
+    }
+
+    @Override
+    public Object getValue() {
+        return this.function.name();
+    }
+
+    @Override
+    public String getLabel() {
+        return "<html><b>" + function.name() + "</b> return " + function.returnType() + "</html>";
+    }
+
+    @Override
+    public String getRenderedValue() {
+        return function.template() == null ? function.name() + "({{}})" : function.template();
+    }
+
+    @Override
     public String getDescription() {
         I18nManager i18n = ToolsLocator.getI18nManager();
 
@@ -72,42 +91,36 @@
         html.append("<html>\n");
 
         Function theFunction = this.getFunction();
-        if (theFunction == null) {
-            html.append("<b>").append(i18n.getTranslation("_Function")).append("</b> ").append(this.getName()).append("<br>\n<br>\n");
-            html.append("<b>").append(i18n.getTranslation("_Return")).append("</b> Object<br>\n<br>\n");
-            html.append("<b>").append(i18n.getTranslation("_Template")).append(":</b> ").append(this.getName()).append("()<br>\n");
-        } else {
-            html.append("<b>").append(i18n.getTranslation("_Function")).append("</b> ").append(this.getName()).append("<br>\n<br>\n");
-            List<String> aliases = theFunction.aliases();
-            if( aliases!=null && !aliases.isEmpty() ) {
-                html.append("<b>").append(i18n.getTranslation("_Aliases")).append(":</b> ").append("<ul>\n");
-                for (String alias : aliases) {
-                    html.append("<li>").append(alias).append("</li>\n");
-                }
-                html.append("</ul>\n");
+        html.append("<b>").append(i18n.getTranslation("_Function")).append("</b> ").append(this.getName()).append("<br>\n<br>\n");
+        List<String> aliases = theFunction.aliases();
+        if( aliases!=null && !aliases.isEmpty() ) {
+            html.append("<b>").append(i18n.getTranslation("_Aliases")).append(":</b> ").append("<ul>\n");
+            for (String alias : aliases) {
+                html.append("<li>").append(alias).append("</li>\n");
             }
-            html.append("<b>").append(i18n.getTranslation("_Return")).append("</b> ");
-            html.append(StringUtils.isEmpty(theFunction.returnType()) ? "Objec" : theFunction.returnType());
-            html.append("<br>\n");
-            html.append("<b>").append(i18n.getTranslation("_Template")).append("</b> ");
-            html.append(StringUtils.isEmpty(theFunction.template()) ? this.getName() + "()" : theFunction.template());
-            html.append("<br>\n");
+            html.append("</ul>\n");
+        }
+        html.append("<b>").append(i18n.getTranslation("_Return")).append("</b> ");
+        html.append(StringUtils.isEmpty(theFunction.returnType()) ? "Objec" : theFunction.returnType());
+        html.append("<br>\n");
+        html.append("<b>").append(i18n.getTranslation("_Template")).append("</b> ");
+        html.append(StringUtils.isEmpty(theFunction.template()) ? this.getName() + "()" : theFunction.template());
+        html.append("<br>\n");
 
-            String[] args = theFunction.descriptionArgs();
-            if (args != null) {
-                html.append("<b>").append(i18n.getTranslation("_Arguments")).append(":</b> ").append("<ul>\n");
-                for (String arg : args) {
-                    html.append("<li>").append(arg).append("</li>\n");
-                }
-                html.append("</ul>\n");
-                html.append("<br>\n");
+        String[] args = theFunction.descriptionArgs();
+        if (args != null) {
+            html.append("<b>").append(i18n.getTranslation("_Arguments")).append(":</b> ").append("<ul>\n");
+            for (String arg : args) {
+                html.append("<li>").append(arg).append("</li>\n");
             }
-            String functionDescription = theFunction.description();
-            if( !StringUtils.isBlank(functionDescription) ) {
-                html.append("<b>").append(i18n.getTranslation("_Description")).append("</b><br>\n");
-                html.append(functionDescription.replace("\n", "<br>")).append("<br>\n");
-            }            
+            html.append("</ul>\n");
+            html.append("<br>\n");
         }
+        String functionDescription = theFunction.description();
+        if( !StringUtils.isBlank(functionDescription) ) {
+            html.append("<b>").append(i18n.getTranslation("_Description")).append("</b><br>\n");
+            html.append(functionDescription.replace("\n", "<br>")).append("<br>\n");
+        }            
 
         html.append("</html>\n");
         return html.toString();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultVariableElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultVariableElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultVariableElement.java	(revision 44259)
@@ -1,7 +1,7 @@
 package org.gvsig.expressionevaluator.swing.impl.elements;
 
 import org.apache.commons.lang3.StringUtils;
-import org.gvsig.expressionevaluator.swing.Element.VariableElement;
+//import org.gvsig.expressionevaluator.swing.Element.VariableElement;
 import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
 import org.gvsig.expressionevaluator.swing.spi.AbstractElement;
 import org.gvsig.tools.ToolsLocator;
@@ -11,16 +11,16 @@
  *
  * @author jjdelcerro
  */
-public class DefaultVariableElement 
-        extends AbstractElement
-        implements VariableElement {
+public class DefaultVariableElement
+        extends AbstractElement //        implements VariableElement 
+{
 
     private final String label;
     private final String source;
     private final String typeName;
     private final String description;
     private final ExpressionBuilderConfig config;
-    
+
     public DefaultVariableElement(ExpressionBuilderConfig config, String label, String source, String name, String typeName, String description) {
         super(name, "expressionbuilder-element");
         this.description = description;
@@ -30,7 +30,7 @@
         this.config = config;
     }
 
-    @Override
+//    @Override
     public String getSource() {
         return this.source;
     }
@@ -40,28 +40,30 @@
         return this.label;
     }
 
-    @Override
+//    @Override
     public String getTypeName() {
         return typeName;
     }
+
     @Override
     public String getDescription() {
-        I18nManager i18n = ToolsLocator.getI18nManager();
+//        I18nManager i18n = ToolsLocator.getI18nManager();
+//
+//        StringBuilder html = new StringBuilder();
+//        html.append("<html>\n");
+//
+//        html.append("<b>").append(this.getLabel()).append("</b><br>\n<br>\n");
+//        html.append("<b>").append(i18n.getTranslation("_Source")).append("</b> ").append(this.getSource()).append("<br>\n");
+//        html.append("<b>").append(i18n.getTranslation("_Name")).append("</b> ").append(this.getName()).append("<br>\n");
+//        html.append("<b>").append(i18n.getTranslation("_Type")).append("</b> ").append(this.getTypeName()).append("<br>\n");
+//        if( !StringUtils.isBlank(this.description) &&
+//                StringUtils.equalsAnyIgnoreCase(this.getName(), this.description) ) {
+//            html.append("<b>").append(i18n.getTranslation("_Description")).append("</b><br>\n");
+//            html.append(this.description.replace("\n", "<br>")).append("<br>\n");
+//        }
+//        html.append("</html>\n");
+//        return html.toString();
+        return null;
+    }
 
-        StringBuilder html = new StringBuilder();
-        html.append("<html>\n");
-
-        html.append("<b>").append(this.getLabel()).append("</b><br>\n<br>\n");
-        html.append("<b>").append(i18n.getTranslation("_Source")).append("</b> ").append(this.getSource()).append("<br>\n");
-        html.append("<b>").append(i18n.getTranslation("_Name")).append("</b> ").append(this.getName()).append("<br>\n");
-        html.append("<b>").append(i18n.getTranslation("_Type")).append("</b> ").append(this.getTypeName()).append("<br>\n");
-        if( !StringUtils.isBlank(this.description) &&
-                StringUtils.equalsAnyIgnoreCase(this.getName(), this.description) ) {
-            html.append("<b>").append(i18n.getTranslation("_Description")).append("</b><br>\n");
-            html.append(this.description.replace("\n", "<br>")).append("<br>\n");
-        }
-        html.append("</html>\n");
-        return html.toString();
-    }
-    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultConstantValueElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultConstantValueElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultConstantValueElement.java	(revision 44259)
@@ -5,6 +5,7 @@
  */
 package org.gvsig.expressionevaluator.swing.impl.elements;
 
+import java.util.Comparator;
 import java.util.Objects;
 import org.gvsig.expressionevaluator.swing.Element.ConstantElement;
 import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
@@ -12,6 +13,7 @@
 import org.gvsig.expressionevaluator.swing.spi.AbstractElement;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.i18n.I18nManager;
+import org.gvsig.tools.util.LabeledValue;
 
 /**
  *
@@ -21,21 +23,28 @@
         extends AbstractElement
         implements ConstantElement {
 
-    private final Object value;
-    private final ExpressionBuilderConfig config;
+    private final String label;
 
-    public DefaultConstantValueElement(ExpressionBuilderConfig config, Object value, String description) {
-        super(Objects.toString(value, ""), "expressionbuilder-element-constant");
-        this.value = value;
-        this.config = config;
+    public DefaultConstantValueElement(Object value, String label, String description) {
+        super(Objects.toString(value,""),  value, "expressionbuilder-element-constant");
+        if( label == null ) {
+            this.label = Objects.toString(value,"");
+        } else {
+            this.label = label;
+        }
     }
 
     @Override
-    public Object getValue() {
-        return value;
+    public String getLabel() {
+        return this.label;
     }
 
     @Override
+    public String getRenderedValue() {
+        return " "+Utils.repr(this.getValue())+" ";
+    }
+
+    @Override
     public String getDescription() {
         I18nManager i18n = ToolsLocator.getI18nManager();
 
@@ -54,4 +63,13 @@
         return html.toString();
     }
 
+    @Override
+    public int compareTo(Object other) {
+        if( !(other instanceof LabeledValue) ) {
+            return super.compareTo(other);
+        }
+        Comparator comparator = Utils.naturalComparator();
+        return comparator.compare(this.getValue(), ((LabeledValue)other).getValue());
+    }
+
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultGroupElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultGroupElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/elements/DefaultGroupElement.java	(revision 44259)
@@ -11,7 +11,6 @@
 import org.gvsig.expressionevaluator.Function;
 import org.gvsig.expressionevaluator.swing.Element;
 import org.gvsig.expressionevaluator.swing.Element.GroupElement;
-import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
 import org.gvsig.expressionevaluator.swing.spi.AbstractElement;
 import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
 
@@ -25,19 +24,16 @@
     {
     
     final private List<Element> elements;
-    final private ExpressionBuilderConfig config;
     private ExpressionEvaluatorSwingManager manager;
 
-    public DefaultGroupElement(ExpressionEvaluatorSwingManager manager, ExpressionBuilderConfig config, String name, List<Element> elements) {
-        super(name, "expressionbuilder-element-group");
+    public DefaultGroupElement(ExpressionEvaluatorSwingManager manager, String name, List<Element> elements) {
+        super(name, name, "expressionbuilder-element-group");
         this.manager = manager;
         this.elements = elements;
-        this.config = config;
     }
 
-    public DefaultGroupElement(ExpressionBuilderConfig config, String name) {
-        super(name, "expressionbuilder-element-group");
-        this.config = config;
+    public DefaultGroupElement(String name) {
+        super(name, name, "expressionbuilder-element-group");
         this.elements = new ArrayList<>();
     }
 
@@ -68,7 +64,7 @@
 
     @Override
     public void addElement(Function function) {
-        Element item = this.manager.createConstantElement(this.config, function);
+        Element item = this.manager.createConstantElement(function, function.name());
         this.addElement(item);
     }
 
